#include <qwidget.h>
#include <qpainter.h>
#include "project.h"
#include <iostream>
#include <cstring>
#include <vector>
#include <cassert>
#include <QPushButton>
#include <QLayout>
#include <QString>
#include <QtGui>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#define psize 250
using namespace std;

MyWidget::MyWidget( int n, QWidget *p, Qt::WindowFlags f )
       : QWidget( p, f ) {
  
   //MyWidget::MyWidget(void)
  xmin = new QLineEdit(this);  // Text-Feld
  xmin->setText( "0" );
  xmax= new QLineEdit(this);  // Text-Feld
  xmax->setText( "0" );

  QPushButton *plot = new QPushButton("Plot",this); // Knopf

  QLabel *xminlab = new QLabel("xmin",this); // label
  QLabel *xmaxlab = new QLabel("xmax",this);
  QVBoxLayout* vlayout = new QVBoxLayout(this);  
  
  vlayout->addWidget(xminlab);
  vlayout->addWidget(xmin);
  vlayout->addWidget(xmaxlab);
  vlayout->addWidget(xmax);
  vlayout->addWidget(plot);


  valueNo = n;
   int i;
   for (i=0; i<n; i++ ){
   values.push_back( XYvalue(0,0));
   }
  QObject::connect(plot,SIGNAL(clicked()),this,SLOT(plotten()));
  
 }

void MyWidget::plotten() { 
  double X=0;
  double Y=0;

 double tmin = (xmin->text()).toDouble();
 double tmax = (xmax->text()).toDouble();
 
 double xr=(double)(tmax-tmin)/psize;
 
 X=tmin;
  for(int i=0; i<psize; i++){
  Y=sin(2*3.14*X);
  values.push_back(XYvalue(X,Y));
   X+=xr;
  }
  update();
}
void MyWidget::paintEvent( QPaintEvent * ) {
   
   QPainter p( this );
   double  xp, yp, xpAlt, ypAlt, diffX, diffY, i;
   minX = maxX = values[0].x;
   minY = maxY = values[0].y;

  for ( int i=1; i<valueNo; i++ ) {
         if ( values[i].x < minX ) minX = values[i].x;
         if ( values[i].x > maxX ) maxX = values[i].x;
         if ( values[i].y < minY ) minY = values[i].y;
         if ( values[i].y > maxY ) maxY = values[i].y;
      }

   xFactor = width() / (maxX -minX),
   yFactor = height() / (maxY -minY);
   // cout << xFactor<<'\t'<< yFactor<<'\n';
   p.setPen( Qt::red) ;
   //p.setBackgroundColor(Qt::white);    // yellow ); //new.... x- und y-Achsen zeichnen
   xp = -minX * xFactor;
   yp = maxY * yFactor;
   p.drawLine( 0, int(yp), width(), int(yp) );  // x-Achse
   p.drawLine( int(xp), 0, int(xp), height() ); // y-Achse

   diffX = (maxX-minX) / 10;        //.... x-Skalen zeichnen/beschriften
   for ( i = -diffX; i>=minX; i-=diffX )
      drawXScale( &p, i, int(yp) );
   for ( i = diffX; i<=maxX; i+=diffX )
      drawXScale( &p, i, int(yp) );

   diffY = (maxY-minY) / 10;        //.... y-Skalen zeichnen/beschriften
   for ( i = -diffY; i>=minY; i-=diffY )
      drawYScale( &p, i, int(xp) );
   for ( i = diffY; i<=maxY; i+=diffY )
      drawYScale( &p, i, int(xp) );
                                   //.... Funktion zeichnen
    xpAlt = xp = ( values[0].x - minX ) * xFactor;
    ypAlt = yp = ( maxY - values[0].y ) * yFactor;
    // cout << xp<<'\t'<< yp<<'\n';
    // cout <<minX<<'\t'<<maxY<<'\n';
   p.setPen( Qt::black);

   for ( i=1; i<valueNo; i++ ) {
     xp = ( values[(int)i].x - minX ) * xFactor;
      yp = ( maxY - values[(int)i].y ) * yFactor;
     // xp = ( values[(int)i].x ) * xFactor;
     // yp = ( values[(int)i].y ) * yFactor;

      // cout <<values[(int)i].x<< '\t' <<values[(int)i].y<<'\n';

       p.drawLine( int(xpAlt), int(ypAlt), int(xp), int(yp) );
//cout <<int(xpAlt)<< '\t' <<int(ypAlt)<<'\t'<<int(xp)<<'\t'<<int(yp)<<'\n';

      xpAlt = xp;
      ypAlt = yp;
   }
   }
/****************************************************************************/
//........... drawXScale
void MyWidget::drawXScale( QPainter *p, double i, int yp ) {
   QString text;
   double  xs = (i-minX) * xFactor;

   text.sprintf( "%.3g", i );
   p->drawLine( int(xs), int(yp-2), int(xs), int(yp+2) );
   p->drawText( int(xs+1), int(yp-2), text );
   p->setPen( QPen( Qt::red, 0, Qt::DotLine ) ); //yellow
   p->drawLine( int(xs), 0, int(xs), height() );
   p->setPen( QPen( Qt::red, 0, Qt::SolidLine ) );//yellow
   }
/*****************************************************************************/
//............drawYScale
void MyWidget::drawYScale( QPainter *p, double i, int xp ) {
   QString text;
   double ys = (maxY-i) * yFactor;

   text.sprintf( "%.3g", i );
   p->drawLine( int(xp-2), int(ys), int(xp+2), int(ys) );
   p->drawText( int(xp+4), int(ys), text );
   p->setPen( QPen( Qt::red, 0, Qt::DotLine ) ); //:yellow
   p->drawLine( 0, int(ys), width(), int(ys) );
   p->setPen( QPen( Qt::red, 0, Qt::SolidLine ) );//yellow
}









/* QString qs;
 qs.setNum(v3);  
 num3->setText(qs);*/ //in Eingabefeld ausgeben
